import Toast from "./../../Toast";
import locale from "./../../locale";

// eslint-disable-next-line
export default {
  // 计算区间, 区间内
  validateRange: function validateRange(value, config) {
    var daysLimit = config.daysLimit;
    var onError = config.onError;
    if (!daysLimit) return true;
    if (!Array.isArray(value) || value.length !== 2) return true;
    var startDate = value[0] instanceof Date ? value[0] : null;
    var endDate = value[1] instanceof Date ? value[1] : null;
    if (startDate && endDate) {
      var diff = startDate.diff(endDate);
      if (diff.days > daysLimit) {
        var errMsg = locale("\u81EA\u5B9A\u4E49\u65F6\u95F4\u533A\u95F4\u4E0D\u80FD\u8D85\u8FC7".concat(daysLimit, "\u5929"), 'hint_error_datepopover_custom_date_range_timeout', [daysLimit]);
        if (onError) {
          onError({
            errMsg: errMsg,
            daysLimit: daysLimit,
            value: value
          });
        } else {
          Toast.show({
            content: errMsg
          });
        }
        return false;
      }
    }
    return true;
  }
};