function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["portal", "getComboDOM", "maskClosable", "value", "list", "onBeforeChange", "onChange", "visible", "onVisibleChange", "maskProps", "wrapperProps", "submitProps", "cancelProps", "ranges", "type", "min", "max", "onError"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
// require PrototypeDate.js和PrototypeString.js
import React, { forwardRef, useRef } from 'react';
import Modal from "./../../Modal";
// 快捷选择
import Quick from "./Quick";
import Custom from "./Custom";
// 非快捷选择
import CustomModal from "./Modal";

// 区间库
import Utils from "./Utils";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var RangeModal = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var portal = _ref.portal,
    getComboDOM = _ref.getComboDOM,
    _ref$maskClosable = _ref.maskClosable,
    maskClosable = _ref$maskClosable === void 0 ? true : _ref$maskClosable,
    value = _ref.value,
    list = _ref.list,
    onBeforeChange = _ref.onBeforeChange,
    onChange = _ref.onChange,
    _ref$visible = _ref.visible,
    visible = _ref$visible === void 0 ? false : _ref$visible,
    onVisibleChange = _ref.onVisibleChange,
    _ref$maskProps = _ref.maskProps,
    maskProps = _ref$maskProps === void 0 ? {} : _ref$maskProps,
    _ref$wrapperProps = _ref.wrapperProps,
    wrapperProps = _ref$wrapperProps === void 0 ? {} : _ref$wrapperProps,
    _ref$submitProps = _ref.submitProps,
    submitProps = _ref$submitProps === void 0 ? {} : _ref$submitProps,
    _ref$cancelProps = _ref.cancelProps,
    cancelProps = _ref$cancelProps === void 0 ? {} : _ref$cancelProps,
    ranges = _ref.ranges,
    _ref$type = _ref.type,
    type = _ref$type === void 0 ? 'date' : _ref$type,
    min = _ref.min,
    max = _ref.max,
    onError = _ref.onError,
    props = _objectWithoutProperties(_ref, _excluded);
  var modalRef = useRef(null);
  // ranges分成两部分: quickRanges(快捷选择)和customRanges(自定义选择)
  var _Utils$getRanges = Utils.getRanges(ranges),
    quickRanges = _Utils$getRanges.quickRanges,
    customRanges = _Utils$getRanges.customRanges;

  // 如果没有快捷选择, 直接渲染自定义选择
  if (Object.isEmptyObject(quickRanges)) {
    return /*#__PURE__*/_jsx(CustomModal, {
      maskClosable: maskClosable,
      value: value,
      ranges: customRanges,
      type: type,
      min: min,
      max: max,
      onError: onError,
      onBeforeChange: onBeforeChange,
      onChange: onChange,
      visible: visible,
      onVisibleChange: onVisibleChange
    });
  }

  // 返回快捷选择
  return /*#__PURE__*/_jsxs(Modal, _objectSpread(_objectSpread({
    ref: modalRef,
    sourceDOM: function sourceDOM() {
      var comboDOM = null;
      if (typeof getComboDOM === 'function') {
        var _comboDOM;
        comboDOM = getComboDOM();
        if (typeof ((_comboDOM = comboDOM) === null || _comboDOM === void 0 ? void 0 : _comboDOM.getRootDOM) === 'function') {
          comboDOM = comboDOM.getRootDOM();
        }
      }
      return comboDOM;
    },
    maskClosable: maskClosable,
    visible: visible,
    animation: "slideDown",
    className: "datepicker-rangemodal-modal",
    onVisibleChange: onVisibleChange
  }, props), {}, {
    children: [/*#__PURE__*/_jsx(Quick, {
      value: value,
      ranges: quickRanges,
      onBeforeChange: onBeforeChange,
      onChange: onChange,
      onVisibleChange: onVisibleChange
    }), /*#__PURE__*/_jsx(Custom, {
      maskClosable: maskClosable,
      value: value,
      ranges: customRanges,
      type: type,
      min: min,
      max: max,
      onError: onError,
      onBeforeChange: onBeforeChange,
      onChange: onChange,
      onVisibleChange: onVisibleChange
    })]
  }));
});
export default RangeModal;