function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["portal", "position", "duration", "maskClickable", "visible", "onVisibleChange", "licon", "ricon", "maskProps", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useEffect, useRef, useImperativeHandle } from 'react';
import { createPortal } from 'react-dom';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var Toast = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var portal = _ref.portal,
    _ref$position = _ref.position,
    position = _ref$position === void 0 ? 'middle' : _ref$position,
    _ref$duration = _ref.duration,
    duration = _ref$duration === void 0 ? 2000 : _ref$duration,
    _ref$maskClickable = _ref.maskClickable,
    maskClickable = _ref$maskClickable === void 0 ? true : _ref$maskClickable,
    _ref$visible = _ref.visible,
    visible = _ref$visible === void 0 ? false : _ref$visible,
    onVisibleChange = _ref.onVisibleChange,
    licon = _ref.licon,
    ricon = _ref.ricon,
    _ref$maskProps = _ref.maskProps,
    maskProps = _ref$maskProps === void 0 ? {} : _ref$maskProps,
    children = _ref.children,
    props = _objectWithoutProperties(_ref, _excluded);
  var rootRef = useRef(null);
  var containerRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      containerDOM: containerRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getContainerDOM: function getContainerDOM() {
        return containerRef.current;
      }
    };
  });
  useEffect(function () {
    handleDuration();
    // 显示时触发onVisibleChange
    if (visible) {
      if (onVisibleChange) onVisibleChange(visible);
    }
    // eslint-disable-next-line
  }, [visible]);

  // 显示数秒后，自动消失
  function handleDuration() {
    if (typeof duration !== 'number' || !duration || !onVisibleChange) {
      return;
    }
    if (rootRef.current.durationTimeout) window.clearTimeout(rootRef.current.durationTimeout);
    rootRef.current.durationTimeout = setTimeout(function () {
      onVisibleChange(false);
    }, duration);
  }

  // 获取激活状态样式
  function getActiveClass() {
    return visible ? ' active' : '';
  }
  return /*#__PURE__*/createPortal( /*#__PURE__*/_jsx("div", _objectSpread(_objectSpread({}, maskProps), {}, {
    className: "mask toast-mask".concat(maskProps.className ? ' ' + maskProps.className : '').concat(maskClickable ? ' toast-propagation' : '').concat(getActiveClass()),
    ref: rootRef,
    children: /*#__PURE__*/_jsx("div", _objectSpread(_objectSpread({
      ref: containerRef
    }, props), {}, {
      className: "toast ".concat(position || 'middle').concat(props.className ? ' ' + props.className : '').concat(getActiveClass()),
      children: /*#__PURE__*/_jsxs("div", {
        className: "toast-wrapper",
        children: [licon && licon, /*#__PURE__*/_jsx("div", {
          className: "toast-content",
          children: children
        }), ricon && ricon]
      })
    }))
  })), portal || document.getElementById('root') || document.body);
});
export default /*#__PURE__*/React.memo(Toast, function (prevProps, nextProps) {
  if (nextProps.visible === prevProps.visible) return true;
  return false;
});